<script lang="ts">
  import { getContext } from 'svelte'

  import { getLocalizer } from '../../../module/utils.js'
  import Dialog from '../../Dialog.svelte'
  import Input from '../../Input.svelte'

  import { Character } from '../../../module/character/character.js'
  import { RollableSkill } from '../../../module/character/skill.js'
  import { CharacterDataAccessor } from '../../../module/model/character.js'
  import { Readable, Writable } from 'svelte/store'
  import { openPDFPage } from '../../../module/pdf-integration.js'
  import { RuleBook } from '../../../module/enums.js'
  import { DataAccessor } from '../../../module/model/item-data.js'
  import { Nameable } from '../../../module/model/utils.js'
  import SpellRoll from '../../roll-dialog/SpellRoll.svelte'

  const localize = getLocalizer()
  const isEditMode = getContext<Readable<boolean>>('isEditMode')
  const application = getContext<any>('#external').application

  let doc = getContext<Writable<CharacterDataAccessor>>('doc')
  let character = new Character($doc)

  export let spell: Nameable<DataAccessor<'spell'>>

  $: skill = RollableSkill.create(spell, character)

  let rollDialog

  function rollSpell(modifiers, options) {
    skill?.roll({ modifiers, ...options })
  }

  let editDialog = () => spell.sheet.render(true)

  function update() {
    spell.update({ ...spell })
  }
</script>

<Dialog
  bind:this={rollDialog}
  title={localize('skillRollDialog')}
  dialogComponent={SpellRoll}
  {character}
  callback={rollSpell}
  {skill}
/>

<!-- svelte-ignore a11y-no-static-element-interactions -->
<div
  class="spell"
  on:change={update}
  data-item-id={spell.id}
  on:dragstart={(event) => application._onDragStart(event)}
  draggable="true"
>
  <div class="spell-label" data-testid="spell-label">
    {#if $isEditMode}
      <!-- svelte-ignore a11y-click-events-have-key-events a11y-no-static-element-interactions a11y-missing-attribute -->
      <a on:click={editDialog} data-testid="spell-edit"
        ><i class="fas fa-wrench" /></a
      >
    {/if}
    <!-- svelte-ignore a11y-click-events-have-key-events a11y-no-static-element-interactions a11y-missing-attribute -->
    <a
      on:click={() =>
        openPDFPage(RuleBook.LiberCantionesDeluxe, spell.system.lcdPage)}
      data-testid="open-pdf"><i class="fas fa-book" /></a
    >

    <!-- svelte-ignore a11y-click-events-have-key-events a11y-no-static-element-interactions a11y-missing-attribute -->
    <a on:click={rollDialog.open} data-testid="spell-roll"
      >{spell.name}
      (
      {localize(spell.system.test.firstAttribute + '_abbr')} /
      {localize(spell.system.test.secondAttribute + '_abbr')} /
      {localize(spell.system.test.thirdAttribute + '_abbr')}
      )</a
    >
  </div>

  <div class="spell-attributes">
    <div data-testid="spell-cost">{spell.system.astralCost}</div>
    <div data-testid="spell-value">
      <Input bind:value={spell.system.value} />
    </div>
  </div>
</div>

<style>
  .spell {
    line-height: 200%;
    font-size: medium;
    display: flex;
  }

  .spell-attributes {
    display: flex;
    justify-content: space-between;
    width: 34%;
  }

  .spell-label {
    width: 66%;
  }
</style>
